var esprima = require("esprima");
var escodegen = require("escodegen");

var target = '/*apicache*/'
var apiCacheTarget = '/*liberty*/';
var apiCacheTargetReg = /\/\*liberty\*\//g;
var autoTarget = "'liberty'";
var autoTargetReg = /'liberty'/g;
var success = false;

function ApiCache(content) {
	let contentCopy = content;
  if (content.includes(apiCacheTarget)) {
    var text = content.slice(content.indexOf(target));
		var source = getBeforeRouter(text);
		var title = 'function ';
		var beforeRouter = getSource(title+source).replace(title,'');
    content = content.replace(source,beforeRouter);
	}
	if(success){
		contentCopy = content;
	}
  return contentCopy;
}

function getBeforeRouter(text){
	var copyText = text.slice(text.indexOf("{") + 1);
    var index = 0,
      count = 1,
      result = {};
    var reg = /{|}/g;
    while (count >= 1 || !result) {
      result = reg.exec(copyText);
      if (result && result[0] == "{") {
        count++;
      } else {
        count--;
      }
    }
    return text.slice(0, result.index + 1 + text.indexOf("{") + 1);
}

function getSource(content) {

  let cacheSave =  {proxy:{cache:true,save:true}};
	let cache =  {proxy:{cache:true}};

	content = content.replace(apiCacheTargetReg,autoTarget);

  var ast = esprima.parseScript(content);

	var source = "" , catchStatus = false;//是否是catch

  ast.body[0].body.body.forEach((item,apiIndex) => {
    if (
      item.type == "ExpressionStatement" &&
      item.expression &&
      item.expression.callee &&
      item.expression.callee.property &&
      (item.expression.callee.property.name == "then" || item.expression.callee.property.name == "catch")
    ) {
			let arg = item.expression.arguments[0];
			if(item.expression.callee.property.name !== "then"){//说明是catch
				arg = item.expression.callee.object.arguments[0];
				catchStatus = true;
			}
      arg.body.body.forEach((module, idx) => {
        if (
          module.type == "ExpressionStatement" &&
          module.expression &&
          module.expression.callee &&
          module.expression.callee.name == "next"
        ) {
					var apiContent = escodegen.generate(item);
					var apiContentOut = apiContent.replace(autoTargetReg,JSON.stringify(cache));
					var apiContentIn = apiContent.replace(autoTargetReg,JSON.stringify(cacheSave));

					ast.body[0].body.body[apiIndex] = esprima.parseScript(apiContentOut);

					var copyApiAst = esprima.parseScript(apiContentIn);

					// content = content.replace(targetReg,JSON.stringify(cache));

					var ApiStatement = copyApiAst.body[0].expression.arguments[0].body;
					if(catchStatus){
						ApiStatement = copyApiAst.body[0].expression.callee.object.arguments[0].body;
					}

					// copyApiAst.expression.callee.object.arguments.forEach((item,index)=>{// 将第二个接口替换为cacheSave
					// 	if(item.properties){
					// 		item.properties.forEach((cacheStatement,idx)=>{
					// 			if(cacheStatement.key.value == "proxy"){
					// 				var cacheSaveAst = esprima.parseScript(`(${JSON.stringify(cacheSave)})`);
					// 				copyApiAst.expression.callee.object.arguments[index].properties[idx] = cacheSaveAst.body[0].expression.properties[0];
					// 			}
					// 		})
					// 	}
					// })

          ApiStatement.body = ApiStatement.body.concat(
            ApiStatement.body[idx].expression.arguments[0].body.body
          );

          ApiStatement.body.splice(idx, 1);

					module.expression.arguments[0].body.body.push(copyApiAst);
					if(catchStatus){
						ast.body[0].body.body[apiIndex].body[0].expression.callee.object.arguments[0].body.body[idx] = module;
					}else{
						ast.body[0].body.body[apiIndex].body[0].expression.arguments[0].body.body[idx] = module;
					}
					

          // var argOut = esprima.parseScript(`(${JSON.stringify(cache)})`).body[0].expression;
          // item.expression.callee.object.arguments.push(argOut);

          // var argIn = esprima.parseScript(`(${JSON.stringify(cacheSave)})`).body[0].expression;
          // copyApiAst.expression.callee.object.arguments.push(argIn);

          var regenerated_code = escodegen.generate(ast);
					source = regenerated_code;
					success = true;
        }
      });
    }
  });
  return source;
}

module.exports = ApiCache;