var a = `<template>
<div id="challenge_task">
	<header>
	<h1 class="left">挑战任务</h1>
	<div class="right" @click="toPage"><span>挑战说明</span><img src="../assets/arrow.png" ></div>
	</header>
	<p class="extra_info" v-text="plan_name"></p>
	<div class="challenge_tasks">
			<swiper :options="swiperOption" ref="mySwiper" class="center">
				<swiper-slide v-for="(item,idx) in list" :key='idx' :class="{submited: item.status == 2, finish:item.status==1,lock:item.lock, timeout: item.status==-1}" @click.native='go(item.lock,item.challenge_id)'>

					<div class="clockImg" v-if="item.lock">
						<img src="../assets/lock.png" alt="">
						<p class="lockText">{{item.lock_text}}</p>
					</div>
					<img src="" alt="" v-if="item.status">
					<img src="" alt="" v-if="!item.status">
					<div class="score_wrap">
						<span v-text="'最高获得'+item.score+'学分'" class="card_score" v-if="item.status==-1 || item.status==0 || item.status == 2"></span>
						<span class="card_score" v-if="item.status == 1">+{{item.score}}</span>

					</div>
					<h3 v-text="item.title" class="card_title" v-if="!item.lock"></h3>
					<span v-text="item.desc" class="des" v-if="!item.lock"></span>
					<div class="date" v-if="item.status == 0 && !item.lock && item.period" >
						<img src="../assets/clock.png" alt="">
						<span class="time" v-text="item.period"></span>
					</div>
				</swiper-slide >
			</swiper>
	</div>
	<div class="group_rank">
		<header>
		 <h1>小组排名</h1>
		</header>
		 <ul class="group_rank">
				<li class="rank_item" :class="{selected_bg:item.is_mine, last_item:item.rank == 3}" v-for="(item,index) in classes" :key="index" v-if="item.rank<=3" @click="toDetail(item)">
					<div class="selected" :class="{hide:!item.is_mine}"><img src="../assets/right_arrow.png" alt=""></div>
					<div class="rank_icon" :class="{rank_icon_1:item.rank==1,rank_icon_2:item.rank==2,rank_icon_3:item.rank==3}"></div>
					<!-- <div class="detail"> -->
					<div class="group_detail" v-if="item.rank<=3">
						<h1 v-text="item.class_name"></h1>
						<ul class="imgs">
							<li v-for="(option,index) in item.avatar"><img :src="option" alt=""></li>

							<li class="num" v-if="item.num">
								<span class="value">+{{item.num}}</span>
							</li>
							<li class="score_wrap"><span class="score"  v-text="item.class_score || 0" :class="{rank_score_1:item.rank==1,rank_score_2:item.rank==2,rank_score_3:item.rank==3}"></span></li>


						</ul>
					<!-- </div> -->

					</div>
					 <img class="right_arrow" src="../assets/arrow.png" :class="{hide:!item.is_mine}">
				</li>
	</ul>
	<ul class="back_rank">
				<li class="my_group" v-for="(item,index) in classes" :key="index" v-if="item.rank>3" @click="toDetail(item)" :class="{selected_bg:item.is_mine}">
					<div class="selected" :class="{hide:!item.is_mine}"><img src="../assets/right_arrow.png" alt=""></div>
					<div class="my_group_wrap">
					<span class="group_num">{{item.rank}}.</span>
					<span class="group_name" v-text="item.class_name"></span>
					<span class="my_group_tag" :class="{hide:!item.is_mine}">(我的小组)</span>
			<div class="right">
			<span class="score" v-text="item.class_score || 0"></span>
			<span class="score_title">分</span>
			 <img src="../assets/arrow.png" v-if="item.is_mine">
			 </div>
				</div>
				</li>
		 </ul>

	</div>
</div>
</template>

<script>
// import Swiper from "mini-swiper";
// import "mini-swiper/miniswiper.css";
function transform(list) {
let flag = false;
let num = 0;
list.forEach(function(item, index) {
	if (!flag) {
		if (item.status == 0) {
			flag = true;
			num += index;
		}
	}
});
return num;
}

import { swiper, swiperSlide } from "vue-awesome-swiper";
require("../swiper.min.css");
export default {
data() {
	return {
		title: "",
		plan_id: "",
		list: [],
		classes: [],
		num: "",
		plan_name: "",
		activeIndex: -1, //clickActiveIndex
		currentIndex: 0, //swiperIndex
		initPage: 0,
		user_content: "",
		routeMap: {
			7: "challenge-intro",
			6: "speech-challenge-intro"
		},
		swiperOption: {
			// NotNextTick is a component's own property, and if notNextTick is set to true, the component will not instantiate the swiper through NextTick, which means you can get the swiper object the first time (if you need to use the get swiper object to do what Things, then this property must be true)
			// notNextTick是一个组件自有属性，如果notNextTick设置为true，组件则不会通过NextTick来实例化swiper，也就意味着你可以在第一时间获取到swiper对象，假如你需要刚加载遍使用获取swiper对象来做什么事，那么这个属性一定要是true
			// notNextTick: true,
			// autoplay: 1500,
			// direction: 'horizontal',
			// autoWidth: true,
			// loop: true,
			// debugger: true,
			centeredSlides: true,
			initialSlide: 0,
			// sensitivity: 5,
			spaceBetween: 20,
			slidesPerView: 1.17
		}
	};
},
components: {
	swiper,
	swiperSlide
},
/*apicache*/
beforeRouteEnter(to, from, next) {
	np.start();
	document.body.style.background = "#fff";
	// let title = to.query.title;
	let plan_id = to.query.plan_id;
	apis.getChallengeTaskDetail({ plan_id: plan_id },/*liberty*/).then(res => {
		next(vm => {
			// vm.title = title;
			vm.plan_id = plan_id;
			vm.list = res.data.list;
			vm.classes = res.data.classes;
			vm.plan_name = res.data.plan_name;
			vm.num = transform(vm.list) || 0;
			vm.initPage = vm.num;
			// vm.swiperOption = Object.assign({}, vm.swiperOption, {initialSlide:3});
			vm.student_id = res.data.student_id || "";
			sessionStorage.pandaclass_student_id = vm.student_id || "";
			// vm.user_content = "pandaclass_write_challenge_content_"+vm.challenge_id+vm.plan_id+vm.student_id;
			// localStorage.pandaclass_user_content  = vm.user_content;
			// console.log(vm.num);
			// vm.$set(vm.swiperOption, vm.swiperOption.initialSlide, vm.num);
			// const data = {
			//   el: ".swiper-container",
			//   spaceBetween: 20,
			//   slidesPerView: "auto",
			//   centeredSlides: true,
			//   initialSlide: vm.num
			// };
			// setTimeout(function() {
			//   const swiper = new Swiper(data);
			// }, 100);
			Al.done();
			np.done();
		});
	});
},
watch: {
	num() {
		// this.$set(this.swiperOption, this.swiperOption.initialSlide, this.num);
	}
},
mounted() {
	this.$nextTick(() => {
		this.$refs.mySwiper.swiper.slideTo(this.initPage);
	});
},
methods: {
	toPage() {
		this.$router.push({ name: "challenge-instruction" });
	},
	toDetail(item) {
		if (item.is_mine) {
			this.$router.push({
				name: "challenge-class-detail",
				query: { plan_id: this.plan_id, class_id: item.class_id }
			});
		}
	},
	go(lock, challenge_id) {
		if (!lock) {
			//
			try {
				this.$router.push({
					// name: this.routeMap[this.plan_id],
					name: "speech-challenge-intro",
					query: { plan_id: this.plan_id, challenge_id: challenge_id }
				});
			} catch (error) {
				this.$router.push({
					name: "challenge-intro",
					query: { plan_id: this.plan_id, challenge_id: challenge_id }
				});
			}
		}
	}
}
};
</script>
<style scoped lang="scss">
#challenge_task {
padding: pr(32) 0 0;
}
.swiper-container {
margin: pr(-32) 0 0 0;
}
.hide {
visibility: hidden;
}
header {
display: flex;
align-items: center;
margin: 0 pr(39) 0 pr(45);
}

h1 {
font-size: pr(40);
font-weight: 500;
text-align: left;
color: #3d3d3d;
}

.right {
flex: 1;
font-size: pr(24);
font-weight: 500;
text-align: right;
color: #ada9a7;
span {
	vertical-align: middle;
}
img {
	vertical-align: middle;
	display: inline-block;
	width: pr(50);
	height: pr(50);
}

// &:after {
//   width: pr(50);
//   height: pr(50);
//   // content: url(../assets/arrow.png);
// }
}

.extra_info {
margin: pr(2) 0 0 pr(45);
@mixin fz 13;
text-align: left;
color: #ada9a7;
}

.swiper-slide {
transition: transform 0.4s;
transform: translateZ(0);
margin-top: pr(75);
margin-bottom: pr(100);
// margin-right: pr(15) !important;
// width: pr(660);
// height: pr(362);
width: pr(594);
// height: pr(325.8);
height: pr(340);
border-radius: 3px;
background: url("../assets/unFinished.png");
background-size: cover;
position: relative;
// box-shadow: 0 20px 40px 0 rgba(253, 150, 75, 0.5);
transform: translateX(-5);
.clockImg {
	position: absolute;
	width: 101%;
	height: 101%;
	.lockText {
		position: absolute;
		top: pr(200);
		margin-top: pr(20);
		font-size: pr(30);
		font-weight: 600;
		color: #ffffff;
		line-height: pr(42);
		text-shadow: 0 pr(2) pr(10) rgba(142, 142, 142, 0.8);
	}
	img {
		top: 0;
		left: 0;
		width: 101%;
		height: 101%;
	}
	p {
		position: absolute;
		z-index: 10;
		top: pr(176);
		left: 50%;
		transform: translateX(-50%);
		/* font-family: PingFangSC; */
		@mixin fz 15;
		font-weight: 600;
		color: #ffffff;
	}
}
.score_wrap {
	width: pr(188);
	height: pr(47);
	border-radius: 0 pr(24) pr(24) 0;
	margin-top: pr(30);
	background-color: #ff9933;
	position: relative;
	/* display: flex;
	align-items: center;
	justify-content: center; */
}
.card_score {
	white-space: nowrap;
	position: absolute;
	top: 50%;
	left: 50%;
	transform: translate(-50%, -50%);
	/* font-family: PingFangSC; */
	font-size: pr(22);
	font-weight: 500;
	color: #ffffff;
}
.card_title {
	position: absolute;
	// margin-top: pr(33);
	white-space: nowrap;
	/* font-family: PingFangSC; */
	// font-size: pr(38);
	// font-weight: bold;
	// font-style: normal;
	// font-stretch: normal;
	font-size: pr(48);
	font-weight: 600;
	line-height: pr(67);
	letter-spacing: 1px;
	color: #ffffff;
	text-shadow: 0 0 pr(20) #cd6523;
	left: pr(35);
	top: pr(110);
}
}

.des {
position: absolute;
// margin-top: pr(15);
left: pr(35);
top: pr(192);
opacity: 0.8;

white-space: nowrap;
/* font-family: PingFangSC; */
font-size: pr(30);
// font-weight: bold;
font-weight: 600;
line-height: pr(44);
letter-spacing: 1px;
color: #fff;
text-shadow: 0 0 pr(10) #be5220;
}

.date {
position: absolute;
left: pr(44);
top: pr(225);
margin-top: pr(19);
img {
	display: inline-block;
	width: pr(20);
	height: pr(20);
	opacity: 0.7;
	object-fit: contain;
	vertical-align: middle;
}

.time {
	line-height: pr(28);
	opacity: 0.7;
	font-size: pr(20);
	font-weight: 500;
	color: #fff;
	// margin-left: pr(10);
}
}

.swiper-slide.finish {
background: url("../assets/finish.png");
background-size: cover;
box-shadow: none;
// width: pr(670);
// margin-left: pr(-10);
// box-shadow: 0 pr(20) pr(40) 0 rgba(253, 150, 75, 0.5);
border-radius: pr(20);
.score_wrap {
	position: relative;
	width: pr(130);
	height: pr(47);
	font-size: pr(30);
	font-weight: 600;
	background-color: #fc6f33;
}
.card_score {
	position: absolute;
	left: pr(52);
	line-height: pr(42);
	&:after {
		display: inline-block;
		margin-left: pr(10);
		width: pr(33);
		line-height: pr(20);
		content: "学分";
		// left: pr(92);
		font-size: pr(14);
		font-weight: 600;
		color: #ffffff;
		vertical-align: middle;
	}
}
.card_title {
	top: pr(100);
}
.des {
	top: pr(177);
}
}

.swiper-slide.submited {
background: url("../assets/submit.png");
background-size: cover;
box-shadow: none;
// width: pr(670);
// margin-left: pr(-10);
// box-shadow: 0 pr(20) pr(40) 0 rgba(253, 150, 75, 0.5);
border-radius: pr(20);

.card_title {
	top: pr(90);
}
.des {
	top: pr(177);
}
}

.swiper-slide.timeout {
background: url("../assets/timeout.png");
background-size: cover;
box-shadow: 0 20px 40px 0 rgba(182, 182, 182, 0.5);
border-radius: pr(20);
.score_wrap {
	background-color: #bcbcbc;
}
.card_title {
	top: pr(100);
	text-shadow: 0 0 pr(20) rgba(142, 142, 142, 0.8);
}

.des {
	top: pr(177);
	text-shadow: 0 0 pr(10) rgba(142, 142, 142, 0.8);
}
}

.swiper-slide.lock {
box-shadow: 0 20px 40px 0 rgba(182, 182, 182, 0.5);
background: none;
.score_wrap {
	background-color: #bcbcbc;
}
}

.swiper-slide.swiper-slide-active {
transform: translateZ(0);
transform: scale(1.05);
}

.num1 .myClass {
color: #ffffff;
}

.item:active {
background-color: #f3f3f3;
}
.back_rank {
padding-bottom: pr(100);
}

.group_rank {
margin-top: pr(22);
// padding-bottom: pr(70);
.rank_item {
	position: relative;
	display: flex;
	align-items: flex-start;
	padding: pr(35) 0;
	height: pr(170);
	// margin: 0 pr(49) 0 pr(55);
	padding-right: pr(49);
	padding-left: pr(55);

	.right_arrow {
		position: absolute;
		top: 0;
		bottom: 0;
		margin: auto 0;
		right: 0;
		// margin-top: pr(20);
		width: pr(50);
		height: pr(50);
	}
	&.selected_bg {
		background-color: #f3f3f3;
	}
	.selected {
		position: absolute;
		left: 0;
		top: 0;
		bottom: 0;
		margin: auto 0;
		width: pr(23);
		height: pr(32);
		object-fit: contain;
		img {
			width: 100%;
			height: 100%;
		}
	}
}
.last_item:last-of-type {
	// margin: 0 pr(45);
	&:after {
		position: absolute;
		content: "";
		display: block;
		height: 1px;
		// width: pr(660);
		left: pr(53);
		right: pr(49);
		bottom: 0;
		background: rgba(207, 206, 204, 0.6);
	}
	// border-bottom: solid 1px rgba(207, 206, 204, 0.6);

	.group_detail {
		border-bottom: none;
	}
}

.rank_icon {
	// align-content: flex-start;
	width: pr(140);
	height: pr(140);
	border-radius: pr(10);
	background: url(../assets/one.png) no-repeat;
	background-size: 100% 100%;
	// background-image: linear-gradient(to bottom, #ececec, #ac9e97);
	// box-shadow: 0 pr(10) pr(20) 0 rgba(192, 185, 181, 0.6);
	img {
		width: 100%;
		height: 100%;
	}
}

.rank_icon_1 {
	background: url(../assets/one.png) no-repeat;
	background-size: 100% 100%;

	// color: #f88c31;
}

.rank_icon_2 {
	background: url(../assets/two.png) no-repeat;
	background-size: 100% 100%;
}

.rank_icon_3 {
	background: url(../assets/three.png) no-repeat;
	background-size: 100% 100%;
}

.group_detail {
	display: inline-block;
	width: pr(510);
	// height: pr(96);

	margin-left: pr(36);
	padding-bottom: pr(41);
	border-bottom: solid 1px rgba(207, 206, 204, 0.6);

	.imgs {
		position: relative;
		margin-top: pr(7);
		height: pr(43);
		font-size: 0;
	}

	li {
		// position: relative;
		display: inline-block;
		margin-left: pr(5);
		width: pr(40);
		height: pr(40);
		border: solid pr(2) rgba(255, 255, 255, 0.7);
		border-radius: 50%;
		img {
			width: 100%;
			height: 100%;
			border-radius: 50%;
		}
	}

	.num {
		// display: flex;
		// align-items: center;
		// justify-content: center;
		line-height: pr(36);
		text-align: center;
		background-color: #cfcecc;
		border: solid pr(3) #ffffff;
		vertical-align: text-bottom;
		.value {
			// @mixin fz 8.5;
			font-size: pr(17);
			font-weight: 600;
			color: #fff;
		}
	}

	.score_wrap {
		position: absolute;
		top: pr(-26);
		right: 0;
		border: none;
	}

	.score {
		position: absolute;
		right: 0;
		line-height: pr(73);
		font-size: pr(52);
		font-weight: 500;

		&:after {
			display: inline;
			// position: absolute;
			margin-left: pr(6);
			// margin-right: pr(15);
			// top: pr(5);
			// left: 100%;
			content: "分";
			font-size: pr(20);
			font-weight: 500;
			vertical-align: 2px;
			// line-height: pr(28);
		}
	}
	.score.rank_score_1 {
		color: #f88c31;
		&:after {
			color: #ff9933;
		}
	}

	.score.rank_score_2 {
		color: #c0b7b2;
		&:after {
			color: #c0b7b2;
		}
	}

	.score.rank_score_3 {
		color: #d1835e;
		&:after {
			color: #d1845f;
		}
	}

	h1 {
		line-height: pr(48);
		font-size: pr(34);
		font-weight: 500;
		text-align: left;
		color: #393129;
	}
}
}
.my_group {
display: flex;
align-items: center;
width: 100%;
height: pr(103);
.my_group_wrap {
	display: flex;
	align-items: center;
	// width: pr(660);
	width: 100%;
	height: pr(100);
	// margin-left: pr(45);
	// margin-right: pr(45);
	margin: 0 pr(49) 0 pr(35);
	border-bottom: solid 1px rgba(207, 206, 204, 0.6);
}

&:last-of-type .my_group_wrap {
	border-bottom: none;
}

&.selected_bg {
	background-color: #f3f3f3;
	.group_num,
	.group_name,
	.right .score,
	.right .score_title {
		color: #ff9933;
	}
}

.selected {
	width: pr(23);
	height: pr(32);
	img {
		width: 100%;
		height: 100%;
	}
}

.group_num {
	margin-left: pr(22);
	@mixin fz 14;
	font-weight: 600;
	color: #736c68;
}

.group_name {
	margin-left: pr(25);
	@mixin fz 14;
	font-weight: 600;
	color: #736c68;
}

.my_group_tag {
	margin-left: pr(14);
	@mixin fz 10;
	font-weight: 500;
	color: #ff9933;
}

.right {
	// margin-right: pr(35);
	font-size: 0;
	.score {
		position: relative;
		line-height: pr(42);
		font-size: pr(30);
		font-weight: 500;
		color: #cfcecc;
		vertical-align: -webkit-baseline-middle;
		// &:after {
		//   position: absolute;
		//   // top: pr(5);
		//   margin-left: pr(7);
		//   content: '分';
		//   left: 100%;
		//   font-size: pr(20);
		//   font-weight: 500;

		// }
	}
	.score_title {
		margin-left: pr(7);
		font-size: pr(20);
		font-weight: 500;
		line-height: pr(28);
		color: #cfcecc;
	}
}
}
</style>
`



var esprima = require("esprima");
var escodegen = require("escodegen");

var target = '/*apicache*/'
var apiCacheTarget = '/*liberty*/';
var returnTarget = '/*return*/'
var apiCacheTargetReg = /\/\*liberty\*\//g;
var autoTarget = "'liberty'";
var autoTargetReg = /'liberty'/g;
var success = false;

function ApiCache(content) {
	let contentCopy = content;
  if (content.includes(apiCacheTarget)) {
    var text = content.slice(content.indexOf(target));
		var source = getBeforeRouter(text);
		var title = 'function ';
		var beforeRouter = getSource(title+source).replace(title,'');
    content = content.replace(source,beforeRouter);
	}
	if(success){
		contentCopy = content;
	}
  return contentCopy.replace(/(return)/g,'return ');
}

function getBeforeRouter(text){
	var copyText = text.slice(text.indexOf("{") + 1);
    var index = 0,
      count = 1,
      result = {};
    var reg = /{|}/g;
    while (count >= 1 || !result) {
      result = reg.exec(copyText);
      if (result && result[0] == "{") {
        count++;
      } else {
        count--;
      }
    }
    return text.slice(0, result.index + 1 + text.indexOf("{") + 1);
}

function getSource(content) {

  let cacheSave =  {proxy:{cache:true,save:true}};
	let cache =  {proxy:{cache:true}};

	content = content.replace(apiCacheTargetReg,autoTarget);

  var ast = esprima.parseScript(content);

	var source = "" , catchStatus = false, returnStatus = false;//是否是catch
  ast.body[0].body.body.forEach((item,apiIndex) => {
		if(!item.expression){//兼容return apis
			returnStatus = true;
			item.expression = item.argument;
		}
    if (
      (item.type == "ExpressionStatement" || item.type == "ReturnStatement") &&
      item.expression &&
      item.expression.callee &&
      item.expression.callee.property &&
      (item.expression.callee.property.name == "then" || item.expression.callee.property.name == "catch")
    ) {
			let arg = item.expression.arguments[0];
			if(item.expression.callee.property.name !== "then"){//说明是catch
				arg = item.expression.callee.object.arguments[0];
				catchStatus = true;
			}
      arg.body.body.forEach((module, idx) => {
        if (
          module.type == "ExpressionStatement" &&
          module.expression &&
          module.expression.callee &&
          module.expression.callee.name == "next"
        ) {
					if(returnStatus){
						delete item.expression;
					}
					var apiContent = escodegen.generate(item).replace(/(return\s*)/,'return');
					var apiContentOut = apiContent.replace(autoTargetReg,JSON.stringify(cache));
					var apiContentIn = apiContent.replace(autoTargetReg,JSON.stringify(cacheSave));

					ast.body[0].body.body[apiIndex] = esprima.parseScript(apiContentOut);

					var copyApiAst = esprima.parseScript(apiContentIn);

					// content = content.replace(targetReg,JSON.stringify(cache));

					var ApiStatement = copyApiAst.body[0].expression.arguments[0].body;
					if(catchStatus){
						ApiStatement = copyApiAst.body[0].expression.callee.object.arguments[0].body;
					}

					// copyApiAst.expression.callee.object.arguments.forEach((item,index)=>{// 将第二个接口替换为cacheSave
					// 	if(item.properties){
					// 		item.properties.forEach((cacheStatement,idx)=>{
					// 			if(cacheStatement.key.value == "proxy"){
					// 				var cacheSaveAst = esprima.parseScript(`(${JSON.stringify(cacheSave)})`);
					// 				copyApiAst.expression.callee.object.arguments[index].properties[idx] = cacheSaveAst.body[0].expression.properties[0];
					// 			}
					// 		})
					// 	}
					// })

          ApiStatement.body = ApiStatement.body.concat(
            ApiStatement.body[idx].expression.arguments[0].body.body
          );

          ApiStatement.body.splice(idx, 1);

					module.expression.arguments[0].body.body.push(copyApiAst);
					if(catchStatus){
						ast.body[0].body.body[apiIndex].body[0].expression.callee.object.arguments[0].body.body[idx] = module;
					}else{
						ast.body[0].body.body[apiIndex].body[0].expression.arguments[0].body.body[idx] = module;
					}
					

          // var argOut = esprima.parseScript(`(${JSON.stringify(cache)})`).body[0].expression;
          // item.expression.callee.object.arguments.push(argOut);

          // var argIn = esprima.parseScript(`(${JSON.stringify(cacheSave)})`).body[0].expression;
          // copyApiAst.expression.callee.object.arguments.push(argIn);

          var regenerated_code = escodegen.generate(ast);
					source = regenerated_code;
					success = true;
        }
      });
    }
  });
  return source;
}

module.exports = ApiCache;

ApiCache(a);